package steamServer

import "github.com/google/uuid"

type Server struct {
    ID          uuid.UUID   `db:"id"`
    RegionID    uuid.UUID   `db:"region_id"`
    GamemodeID  uuid.UUID   `db:"gamemode_id"`
    AppID       int         `db:"app_id"`
    ServerIP    string      `db:"server_ip"`
    Name        string      `db:"name"`
    Map         string      `db:"map"`
    Players     int         `db:"players"`
    MaxPlayers  int         `db:"max_players"`
}

type ServerStore interface {
    Server(id uuid.UUID) (Server, error)
    Servers() ([]Server, error)
    CreateServer(ser *Server) error
    UpdateServerByQuery(ser *Server) error
}

type Store interface {
    ServerStore
}
